WSL2(3)安装Linux headers完美解决方案

简介: WSL2(3)安装Linux headers完美解决方案

这个笔记是我当时闲着无聊,学driver开发的时候 本来有虚拟机可以用,但是我非要用wsl2 开发。非常麻烦!折腾了至少半天。最后硬刚解决 ,完美可以通过wsl2 开发linux driver程序。

首先,尝试在WSL上安装Linux headers,发现不能通过apt install linux-headers-$(uname -r)进行安装。原因是WSL与传统的Linux发行版不同,它不需要编译内核模块,因此也不需要安装linux-headers软件包。如果你需要使用某个软件包,它需要内核模块支持,那么你可以尝试使用apt安装该软件包,它将自动安装所需的内核模块。如果你需要编译某个内核模块,你需要安装一个完整的Linux发行版(例如Ubuntu、Debian等),并在其中编译和安装内核模块。

root@DESKTOP-FS9U3GT:/lib/modules# uname -a
Linux DESKTOP-FS9U3GT 5.10.102.1-microsoft-standard-WSL2 #1 SMP Wed Mar 2 00:30:59 UTC 2022 x86_64 x86_64 x86_64 GNU/Linux
root@DESKTOP-FS9U3GT:/lib/modules# apt install linux-headers-$(uname -r)
Reading package lists... Done
Building dependency tree
Reading state information... Done
E: Unable to locate package linux-headers-5.10.102.1-microsoft-standard-WSL2
E: Couldn't find any package by glob 'linux-headers-5.10.102.1-microsoft-standard-WSL2'

下载WSL2-Linux-Kernel

在Windows环境下,通过git clone https://github.com/microsoft/WSL2-Linux-Kernel.git可以下载源码,但是会报错,因为某些路径在Windows文件系统中是无效的。因此,尝试在WSL环境下下载,但是由于网络问题需要使用代理。可以使用如下命令下载并检查内核版本:

# 下载源码
git clone https://ghproxy.com/https://github.com/microsoft/WSL2-Linux-Kernel.git
 
# 查看git tags
git tags
 
# 检出对应的内核版本
git checkout tags/linux-msft-wsl-5.10.102.1

出现网络问题时,可以通过增加git的缓冲区大小解决:

git config --global http.postBuffer 5242880000

编译内核模块

首先,尝试编译内核模块,但是报错,需要进行一些设置。首先,创建内核模块构建目录并创建软链接:

mkdir -p /lib/modules/5.10.102.1-microsoft-standard-WSL2/build
sudo ln -sf /usr/src/linux-headers-$(uname -r) /lib/modules/$(uname -r)/build

解压内核源码到/usr/src目录下,然后使用make oldconfigmake prepare来生成配置。出现

缺失头文件的错误时,可以使用sudo apt-get install libssl-dev来安装libssl-dev包,如果提示缺失libelf-dev,使用sudo sudo apt-get install libelf-dev来安装。

如果make prepare命令执行成功,那么就可以尝试编译内核模块。在编译内核模块时,如果遇到错误,可以根据给出的错误信息进行相应的操作。例如,如果出现“无法生成ORC元数据”的错误,那么可能需要安装libelf-dev软件包。

最后成功编译生成ko文件,通过insmod命令尝试加载ko文件。如果遇到版本魔数不匹配的错误,那么需要修改Makefile文件,将其中的5.10.102.1+ SMP mod_unload修改为5.10.102.1-microsoft-standard-WSL2 SMP mod_unload modversions

EXTRA_CFLAGS += -DCONFIG_MODVERSIONS -DMODULE -D"KBUILD_STR(s)=#s" -D"KBUILD_BASENAME=KBUILD_STR(mychardev)" -D"KBUILD_MODNAME=KBUILD_STR(mychardev)" -Wno-declaration-after-statement
VERSION = 5
PATCHLEVEL = 10
SUBLEVEL = 102
EXTRAVERSION = .1-microsoft-standard-WSL2

mod_unload modversions,可以使用以下方法:

  1. 进入内核源代码目录,执行 make kernelversion 命令,获取内核版本号,例如 5.10.102.1-microsoft-standard-WSL2。
  2. 编辑内核模块源代码目录下的 Makefile 文件,在文件开头添加以下内容:

其中 EXTRA_CFLAGS 选项用于指定编译参数,VERSION、PATCHLEVEL 和 SUBLEVEL 分别表示主版本号、次版本号和补丁级别,EXTRAVERSION 表示额外的版本号,需要根据上一步获取到的内核版本号进行修改

如果有任何问题,欢迎留言。

相关文章
|
5天前
|
Web App开发 安全 Linux
Linux系统之安装Firefox浏览器
【7月更文挑战第8天】Linux系统之安装Firefox浏览器
27 8
|
7天前
|
存储 Ubuntu Java
【Linux】已解决:Ubuntu虚拟机安装Java/JDK
【Linux】已解决:Ubuntu虚拟机安装Java/JDK
13 1
|
1天前
|
缓存 Linux 测试技术
安装【银河麒麟V10】linux系统--并挂载镜像12
【7月更文挑战第12天】安装【银河麒麟V10】linux系统--并挂载镜像
6 0
|
4天前
|
Ubuntu 安全 Linux
Linux系统之安装Ninvaders太空入侵者小游戏
【7月更文挑战第9天】Linux系统之安装Ninvaders太空入侵者小游戏
11 0
|
10天前
|
关系型数据库 MySQL Linux
Linux部署实战前言,MySQL在CentOS安装【单机软件】,MySQL的安装需要root权限,yum install mysql,systemctl enable mysqld开机自启的意思
Linux部署实战前言,MySQL在CentOS安装【单机软件】,MySQL的安装需要root权限,yum install mysql,systemctl enable mysqld开机自启的意思
|
18天前
|
NoSQL Java Linux
linux 安装 neo4j简介
Neo4j是高性能NoSQL图形数据库,利用图结构存储数据。推荐使用JDK 11配合Neo4j 3.x版本。下载3.5.9版,通过`curl`命令在Linux上获取tar.gz文件,然后解压。配置`neo4j.conf`,调整内存设置,开启远程访问。执行`./bin/neo4j start`启动,通过`http://服务器IP:7474`访问,默认凭据是username: neo4j, password: neo4j,登录后应更改密码。
33 0
|
存储 缓存 Ubuntu
【嵌入式开发】 Linux Kernel 下载 配置 编译 安装 及 驱动简介(二)
【嵌入式开发】 Linux Kernel 下载 配置 编译 安装 及 驱动简介(二)
184 0
|
Ubuntu 安全 Unix
【嵌入式开发】 Linux Kernel 下载 配置 编译 安装 及 驱动简介(一)
【嵌入式开发】 Linux Kernel 下载 配置 编译 安装 及 驱动简介(一)
228 0